// Bits is Bits
// Eric Mika, ITP Math Driveby, October 14 2010

// A brute-force example designed to emphasise the fact that the representational qualities of
// a particular string of data is a matter of interpretation. This example reinterprets sound
// samples from the microphone into an image.

import ddf.minim.*;

Minim minim;
AudioInput in;
PImage imageOutput;

void setup() {
  size(768, 256);

  minim = new Minim(this);

  // get a line in from Minim, default bit depth is 16
  in = minim.getLineIn(Minim.STEREO, 1024);


  imageOutput = createImage(32, 32, RGB);
}

void draw()
{
  background(0);

  // Draw the waveform and load the sound data into the image
  imageOutput.loadPixels();

  colorMode(HSB);    
  noFill();  
  smooth();
  strokeWeight(2);
  stroke(255);  
  beginShape();
  for (int i = 0; i < 1024; i++) {
    vertex(map(i, 0, 1024, 0, 512), map(in.left.get(i), -1, 1, 0, 256));

    imageOutput.pixels[i] = color(round(map(in.left.get(i), -1, 1, 0, 256)), 255, 128);
  }
  endShape();

  colorMode(RGB);    
  fill(255, 0, 0);
  text("Sound to Image", 10, 20);

  imageOutput.updatePixels();

  // Draw the pixels
  noSmooth();
  noStroke();
  image(imageOutput, 512, 0, 256, 256);
}


void stop() {
  // always close Minim audio classes when you are done with them
  in.close();
  minim.stop();

  super.stop();
}

